unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdHTTP, IdCookieManager, StdCtrls, IdServerIOHandler, IdSSLOpenSSL,
  IdIOHandler, IdIOHandlerSocket;

type
  TForm1 = class(TForm)
    IdHTTP1: TIdHTTP;
    IdCookieManager1: TIdCookieManager;
    Memo1: TMemo;
    IdSSLIOHandlerSocket1: TIdSSLIOHandlerSocket;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  Params: TStringList;
  HTML, loginurl, signinurl, userid: String;
  count,i:integer;
  cookies:tstringlist;

   procedure setcookies;
   var j:integer;
   begin
       count:=IdCookieManager1.CookieCollection.count;
       for j:=1 to count do
           IdHTTP1.Request.RawHeaders.Add('Cookie'+IdHTTP1.Request.RawHeaders.NameValueSeparator+IdCookieManager1.CookieCollection.Items[j-1].CookieText);
   end;

begin
  signinurl:='http://signin.ebay.com/ws/eBayISAPI.dll?SignIn&ssPageName=h:h:sin:US';
  // the above is used to get the login page (this is the link from the "sign in" link.
  // you have to emulate a browser, so you need to do all steps. this is a good idea to do
  // since all redirects might set cookies that you will probably need

  loginurl:='https://signin.ebay.com/ws/eBayISAPI.dll?co_partnerid=2&amp;siteid=0&amp;UsingSSL=1';
  // the above is the login url. this is the url from the action property of the form; this is where
  // the login request will be sent

  Params := TStringList.Create;
  try
    cookies:=tstringlist.Create;

    html:=idhttp1.Get(signinurl);// first get; get first cookie(s)
    // there will be one redirect which will set exactly 4 cookies
    
    count:=IdCookieManager1.CookieCollection.count;// get them
    for i:=1 to count do
     cookies.Add(IdCookieManager1.CookieCollection.Items[i-1].CookieText);

    // you might want to parse the hidden inputs name and value
    // because hard-coding them might not work in the future or in case there are
    // values that are generated
    Params.Values['MfcISAPICommand'] := 'SignInWelcome';// now fill in the login form
    // the above is a hidden input, but still needs to be sent

    Params.Values['siteid'] := '0';
    // the above is a hidden input, but still needs to be sent

    Params.Values['co_partnerId'] := '2';
    // the above is a hidden input, but still needs to be sent

    Params.Values['UsingSSL'] := '1';
    // the above is a hidden input, but still needs to be sent

    Params.Values['ru'] := '';
    // the above is a hidden input, but still needs to be sent

    Params.Values['pp'] := '';
    // the above is a hidden input, but still needs to be sent

    Params.Values['pa1'] := '';
    // the above is a hidden input, but still needs to be sent

    Params.Values['pa2'] := '';
    // the above is a hidden input, but still needs to be sent

    Params.Values['pa3'] := '';
    // the above is a hidden input, but still needs to be sent

    Params.Values['i1'] := '-1';
    // the above is a hidden input, but still needs to be sent

    Params.Values['pageType'] := '-1';
    // the above is a hidden input, but still needs to be sent

    Params.Values['rtmData'] := '';
    // the above is a hidden input, but still needs to be sent

    userid:=<your ebay id here>;
    Params.Values['userid'] := userid;
    Params.Values['pass'] := <your ebay password here>;
    Params.Values['keepMeSignInOption'] := '1';

    // also note that there is a javascript function to be called at onsubmit "setOptimCookie()"

    setCookies;
    HTML := IdHTTP1.Post(loginurl, Params);// now do the log in

    setcookies;
    HTML := IdHTTP1.Get('http://my.ebay.com/ws/eBayISAPI.dll?MyeBay');// this is because:
    // "If you are seeing this page, your browser settings prevent you from automatically
    // redirecting to a new URL."
    
    if pos('Hello, </span><a href="http://contact.ebay.com/ws/eBayISAPI.dll?'+
                                    'ReturnUserEmail&amp;requested='+userid,html)>0 then
    begin  // we are logged in
      setcookies;// cookies must be set before every request
      HTML := IdHTTP1.Get(<whatever url you need>);
    end               else
      showmessage('login failed');

  except
    on e: EIdHTTPProtocolException do
    begin
      memo1.lines.add(idHTTP1.response.ResponseText);
      memo1.lines.add(e.ErrorMessage);
    end;
  end;
  Params.Free;
  memo1.Lines.Text:=html;
end;

end.
